import { DependencyContainer } from "./DependencyContainer";
import { LoggerService } from './Services/Logging/LoggerService';
import { nameof } from "ts-simple-nameof";
import { LocalStorageService } from "./Services/LocalStorageService";
import { ExalusConnectionService } from './ExalusConnectionService';
import { WebApiCacheService } from "./Services/WebApi/WebApiCacheService";
import { UsersService } from "./Services/Users/UsersService";
import { DevicesService } from "./Services/Devices/DevicesService";
var Api = (function () {
    function Api() {
    }
    Api.Init = function () {
        DependencyContainer.Instance.RegisterService(new LocalStorageService());
        DependencyContainer.Instance.RegisterService(new WebApiCacheService());
        DependencyContainer.Instance.RegisterService(new ExalusConnectionService());
        DependencyContainer.Instance.RegisterService(new UsersService());
        DependencyContainer.Instance.RegisterService(new DevicesService());
    };
    Api.GetAsync = function (classType, cancelationToken) {
        DependencyContainer.Instance.GetService(LoggerService).Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetServiceAsync(classType, cancelationToken);
    };
    Api.GetWithTimeoutAsync = function (classType, timeout) {
        DependencyContainer.Instance.GetService(LoggerService).Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetServiceWithTimeoutAsync(classType, timeout);
    };
    Api.Get = function (classType) {
        DependencyContainer.Instance.GetService(LoggerService).Log(Api, "[DI] [API] Get<".concat(nameof(classType), ">"));
        return DependencyContainer.Instance.GetService(classType);
    };
    Api.Version = 1.0;
    return Api;
}());
export { Api };
//# sourceMappingURL=Api.js.map