import { IDIService } from "./IDIService";
import { CancelationTokenSource } from './CancelationTokenSource';
export declare class DependencyContainer {
    private static _instance;
    private _services;
    private _serviceRegistrationEvent;
    private static _log?;
    static get Instance(): DependencyContainer;
    RegisterService(service: IDIService): void;
    GetService<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }): T;
    GetServiceAsync<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }, token?: CancelationTokenSource): Promise<T>;
    GetServiceWithTimeoutAsync<T extends IDIService>(classType: {
        new (...params: any[]): T;
    }, timeout: number): Promise<T>;
}
