import { Api } from './Api';
import { LoggerService } from './Services/Logging/LoggerService';
var TypedEvent = (function () {
    function TypedEvent() {
        this._log = Api.Get(LoggerService);
        this.handlers = [];
    }
    TypedEvent.prototype.Subscribe = function (handler) {
        this.handlers.push(handler);
    };
    TypedEvent.prototype.Unsubscribe = function (handler) {
        this.handlers = this.handlers.filter(function (h) { return h !== handler; });
    };
    TypedEvent.prototype.Invoke = function (data) {
        var _this = this;
        this.handlers.slice(0).forEach(function (h) {
            try {
                h(data);
            }
            catch (ex) {
                _this._log.Error(ex);
            }
        });
    };
    return TypedEvent;
}());
export { TypedEvent };
//# sourceMappingURL=TypedEvent.js.map